"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
exports.__esModule = true;
exports.onAuthStateChanged = exports.signInWithAccessToken = exports.signInWithCredential = exports.getRedirectResult = exports.linkWithPopup = exports.linkWithRedirect = exports.linkWithAccessToken = exports.linkWithCredential = exports.signOut = exports.signInWithRedirect = exports.signInWithPopup = exports.updateEmail = exports.updateProfile = exports.sendEmailVerification = exports.createUserWithEmailAndPassword = exports.signInWithEmailAndPassword = exports.fetchSignInMethodsForEmail = exports.sendPasswordResetEmail = exports.analyticsLogger = exports.getUserId = exports.getUserToken = exports.getCurrentUser = exports.getCredential = exports.getProvider = exports.getAuth = exports.makeAnalyticsActive = exports.makeFirebaseActive = void 0;
var eventBus_1 = require("./eventBus");
var dataPromises = {
    authModule: null,
    firebaseApp: null,
    analyticsModule: null
};
var firebaseConfig = {};
/**
 * Loads the firebase app module and initiazez firebase with firebase config
 *
 * @returns A Promise to the firebase app instance
 */
function initializeApp() {
    return new Promise(function (resolve) {
        eventBus_1.EventBus.$on("resolveFirebase", function () {
            Promise.resolve().then(function () { return __importStar(require("firebase/app")); }).then(function (appModule) {
                var app = appModule.initializeApp(firebaseConfig);
                resolve(app);
            });
        }, true);
    });
}
/**
 * Makes firebase calls active i.e all calls will only start resolving
 * after this function is called
 * * Also the function isn't expected to be called more than once
 */
var makeFirebaseActive = function (config) {
    Object.assign(firebaseConfig, config);
    if (dataPromises.firebaseApp === null)
        dataPromises.firebaseApp = initializeApp();
    eventBus_1.EventBus.$emit("resolveFirebase");
};
exports.makeFirebaseActive = makeFirebaseActive;
/**
 * Dynamically Loads the firebase auth module returns a
 * promise that resolves into auth module
 *
 * @returns {Promise<any>} A Promise to load firebase auth module
 */
function loadFirebaseAuth() {
    return __awaiter(this, void 0, void 0, function () {
        var authModule;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, dataPromises.firebaseApp];
                case 1:
                    _a.sent();
                    return [4 /*yield*/, Promise.resolve().then(function () { return __importStar(require("firebase/auth")); })];
                case 2:
                    authModule = _a.sent();
                    return [2 /*return*/, authModule];
            }
        });
    });
}
/**
 * Dynamically loads firebase analytics and returns a promise to analytics module
 * @returns {Promise<AnalyticsModule>} A Promise to loads firebase analytics
 */
function loadFirebaseAnalytics() {
    var _this = this;
    return new Promise(function (resolve) {
        eventBus_1.EventBus.$on("resolveAnalytics", function () { return __awaiter(_this, void 0, void 0, function () {
            var module, analyticsModule;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, dataPromises.firebaseApp];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, Promise.resolve().then(function () { return __importStar(require("firebase/analytics")); })];
                    case 2:
                        module = _a.sent();
                        analyticsModule = (function (_a) {
                            var getAnalytics = _a.getAnalytics, logEvent = _a.logEvent;
                            return ({ getAnalytics: getAnalytics, logEvent: logEvent });
                        })(module);
                        resolve(analyticsModule);
                        return [2 /*return*/];
                }
            });
        }); });
    });
}
/**
 * Makes firebase calls active i.e all calls will only start resolving
 * after this function is called
 * * Also the function isn't expected to be called more than once
 */
var makeAnalyticsActive = function () {
    if (dataPromises.analyticsModule === null)
        dataPromises.analyticsModule = loadFirebaseAnalytics();
    eventBus_1.EventBus.$emit("resolveAnalytics");
};
exports.makeAnalyticsActive = makeAnalyticsActive;
/**
 * Returns a promise which resolves into firebase auth module
 * @returns {Promise<any>} A Promise which resolves into firebase auth module
 */
function getAuthModule() {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!(dataPromises.firebaseApp === null)) return [3 /*break*/, 2];
                    dataPromises.firebaseApp = initializeApp();
                    return [4 /*yield*/, dataPromises.firebaseApp];
                case 1:
                    _a.sent();
                    _a.label = 2;
                case 2:
                    if (dataPromises.authModule !== null) {
                        return [2 /*return*/, dataPromises.authModule];
                    }
                    dataPromises.authModule = loadFirebaseAuth();
                    return [2 /*return*/, getAuthModule()];
            }
        });
    });
}
/**
 * Returns a promise which resolves into firebase analytics module
 * @returns {Promise<AnalyticsModule>} A Promise which resolves into firebase auth module
 */
function getAnalyticsModule() {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!(dataPromises.firebaseApp === null)) return [3 /*break*/, 2];
                    dataPromises.firebaseApp = initializeApp();
                    return [4 /*yield*/, dataPromises.firebaseApp];
                case 1:
                    _a.sent();
                    _a.label = 2;
                case 2:
                    if (dataPromises.analyticsModule !== null) {
                        return [2 /*return*/, dataPromises.analyticsModule];
                    }
                    dataPromises.analyticsModule = loadFirebaseAnalytics();
                    return [2 /*return*/, getAnalyticsModule()];
            }
        });
    });
}
/**
 * Returns the Auth instance associated with the provided {@link @firebase/app#FirebaseApp}.
 * If no instance exists, initializes an Auth instance with platform-specific default dependencies.
 *
 * @param {FirebaseApp} - The Firebase App.
 * @returns {Promise<Auth>} A Promise to the firebase auth module
 *
 */
function getAuth(app) {
    return __awaiter(this, void 0, void 0, function () {
        var authModule;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, getAuthModule()];
                case 1:
                    authModule = _a.sent();
                    return [2 /*return*/, authModule.getAuth(app)];
            }
        });
    });
}
exports.getAuth = getAuth;
/**
 *
 * @param {string} provider the name of provider {google, facebook, github}
 * @returns this function returns AuthProvider/Credential instance
 */
function getProvider(provider) {
    return __awaiter(this, void 0, void 0, function () {
        var authModule;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, getAuthModule()];
                case 1:
                    authModule = _a.sent();
                    switch (provider) {
                        case "google": return [2 /*return*/, new authModule.GoogleAuthProvider()];
                        case "facebook": return [2 /*return*/, new authModule.FacebookAuthProvider()];
                        case "github": return [2 /*return*/, new authModule.GithubAuthProvider()];
                        default: throw Error("Unknown provider '".concat(provider, "'"));
                    }
                    return [2 /*return*/];
            }
        });
    });
}
exports.getProvider = getProvider;
/**
 *
 * @param {Provider} provider the name of provider {google, facebook, github}
 * @param {string} accessToken return by new priveder
 * @returns this function returns AuthProvider/Credential instance
 */
function getCredential(provider, accessToken) {
    return __awaiter(this, void 0, void 0, function () {
        var authModule;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, getAuthModule()];
                case 1:
                    authModule = _a.sent();
                    switch (provider) {
                        case "google": return [2 /*return*/, authModule.GoogleAuthProvider.credential(accessToken)];
                        case "facebook": return [2 /*return*/, authModule.FacebookAuthProvider.credential(accessToken)];
                        case "github": return [2 /*return*/, authModule.GithubAuthProvider.credential(accessToken)];
                        default: throw Error("Unknown provider '".concat(provider, "'"));
                    }
                    return [2 /*return*/];
            }
        });
    });
}
exports.getCredential = getCredential;
var userLoaded = false;
/**
 * Function gets the user data asynchronously
 *
 * @returns {User | null} - user data
 */
function getCurrentUser() {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            return [2 /*return*/, new Promise(function (resolveUser, rejectUser) {
                    if (userLoaded) {
                        getAuth().then(function (auth) {
                            resolveUser(auth.currentUser);
                        });
                        return;
                    }
                    getAuth().then(function (auth) {
                        var unsubscribe = auth.onAuthStateChanged(function (user) {
                            userLoaded = true;
                            unsubscribe();
                            resolveUser(user);
                        }, rejectUser);
                    });
                })];
        });
    });
}
exports.getCurrentUser = getCurrentUser;
/**
 * Function gets the user token
 *
 * @returns {Promise<string>} - user token
 */
function getUserToken() {
    var _a, _b;
    return __awaiter(this, void 0, void 0, function () {
        var authModule;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0: return [4 /*yield*/, getAuthModule()];
                case 1:
                    authModule = _c.sent();
                    return [2 /*return*/, (_b = (_a = authModule === null || authModule === void 0 ? void 0 : authModule.getAuth()) === null || _a === void 0 ? void 0 : _a.currentUser) === null || _b === void 0 ? void 0 : _b.getIdToken()];
            }
        });
    });
}
exports.getUserToken = getUserToken;
/**
 * Function get the user id
 *
 *  @returns {Promise<string>} - return the user id
 */
function getUserId() {
    var _a, _b;
    return __awaiter(this, void 0, void 0, function () {
        var authModule;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0: return [4 /*yield*/, getAuthModule()];
                case 1:
                    authModule = _c.sent();
                    return [2 /*return*/, (_b = (_a = authModule.getAuth()) === null || _a === void 0 ? void 0 : _a.currentUser) === null || _b === void 0 ? void 0 : _b.uid];
            }
        });
    });
}
exports.getUserId = getUserId;
/**
 *
 * @logs production events in google analytics
 * refer : https://firebase.google.com/docs/analytics/events?platform=web#web-version-9_1
 * Refer the above link to know more about the syntax of firebase version 9
*/
function analyticsLogger(logType, logObject) {
    // Logs to be sent only in production environment
    if (process.env.NODE_ENV !== "production")
        return;
    getAnalyticsModule().then(function (analyticsModule) {
        analyticsModule.logEvent(analyticsModule.getAnalytics(), logType, logObject);
    })["catch"](function (err) {
        console.log("Analytics couldn't be loaded", err);
    });
}
exports.analyticsLogger = analyticsLogger;
// Dummy Functionss for firebase auth, these hold the call while firebase auth loads in background
function sendPasswordResetEmail(email, actionCodeSettings) {
    return __awaiter(this, void 0, void 0, function () {
        var authModule;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, getAuthModule()];
                case 1:
                    authModule = _a.sent();
                    return [2 /*return*/, authModule.sendPasswordResetEmail(authModule.getAuth(), email, actionCodeSettings)];
            }
        });
    });
}
exports.sendPasswordResetEmail = sendPasswordResetEmail;
function fetchSignInMethodsForEmail(email) {
    return __awaiter(this, void 0, void 0, function () {
        var authModule;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, getAuthModule()];
                case 1:
                    authModule = _a.sent();
                    return [2 /*return*/, authModule.fetchSignInMethodsForEmail(authModule.getAuth(), email)];
            }
        });
    });
}
exports.fetchSignInMethodsForEmail = fetchSignInMethodsForEmail;
function signInWithEmailAndPassword(email, password) {
    return __awaiter(this, void 0, void 0, function () {
        var authModule;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, getAuthModule()];
                case 1:
                    authModule = _a.sent();
                    return [2 /*return*/, authModule.signInWithEmailAndPassword(authModule.getAuth(), email, password)];
            }
        });
    });
}
exports.signInWithEmailAndPassword = signInWithEmailAndPassword;
function createUserWithEmailAndPassword(email, password) {
    return __awaiter(this, void 0, void 0, function () {
        var authModule;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, getAuthModule()];
                case 1:
                    authModule = _a.sent();
                    return [2 /*return*/, authModule.createUserWithEmailAndPassword(authModule.getAuth(), email, password)];
            }
        });
    });
}
exports.createUserWithEmailAndPassword = createUserWithEmailAndPassword;
function sendEmailVerification(user, actionCodeSettings) {
    return __awaiter(this, void 0, void 0, function () {
        var authModule;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, getAuthModule()];
                case 1:
                    authModule = _a.sent();
                    return [2 /*return*/, authModule.sendEmailVerification(user, actionCodeSettings)];
            }
        });
    });
}
exports.sendEmailVerification = sendEmailVerification;
function updateProfile(user, payload) {
    return __awaiter(this, void 0, void 0, function () {
        var authModule;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, getAuthModule()];
                case 1:
                    authModule = _a.sent();
                    return [2 /*return*/, authModule.updateProfile(user, payload)];
            }
        });
    });
}
exports.updateProfile = updateProfile;
function updateEmail(user, newEmail) {
    return __awaiter(this, void 0, void 0, function () {
        var authModule;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, getAuthModule()];
                case 1:
                    authModule = _a.sent();
                    return [2 /*return*/, authModule.updateEmail(user, newEmail)];
            }
        });
    });
}
exports.updateEmail = updateEmail;
function signInWithPopup(provider, resolver) {
    return __awaiter(this, void 0, void 0, function () {
        var authModule, provid;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, getAuthModule()];
                case 1:
                    authModule = _a.sent();
                    return [4 /*yield*/, getProvider(provider)];
                case 2:
                    provid = _a.sent();
                    return [2 /*return*/, authModule.signInWithPopup(authModule.getAuth(), provid, resolver)];
            }
        });
    });
}
exports.signInWithPopup = signInWithPopup;
function signInWithRedirect(provider, resolver) {
    return __awaiter(this, void 0, void 0, function () {
        var authModule, provid;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, getAuthModule()];
                case 1:
                    authModule = _a.sent();
                    return [4 /*yield*/, getProvider(provider)];
                case 2:
                    provid = _a.sent();
                    return [2 /*return*/, authModule.signInWithRedirect(authModule.getAuth(), provid, resolver)];
            }
        });
    });
}
exports.signInWithRedirect = signInWithRedirect;
function signOut() {
    return __awaiter(this, void 0, void 0, function () {
        var authModule;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, getAuthModule()];
                case 1:
                    authModule = _a.sent();
                    return [2 /*return*/, authModule.signOut(authModule.getAuth())];
            }
        });
    });
}
exports.signOut = signOut;
function linkWithCredential(user, credential) {
    return __awaiter(this, void 0, void 0, function () {
        var authModule;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, getAuthModule()];
                case 1:
                    authModule = _a.sent();
                    return [2 /*return*/, authModule.linkWithCredential(user, credential)];
            }
        });
    });
}
exports.linkWithCredential = linkWithCredential;
function linkWithAccessToken(user, provider, accessToken) {
    return __awaiter(this, void 0, void 0, function () {
        var authModule, credential;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, getAuthModule()];
                case 1:
                    authModule = _a.sent();
                    return [4 /*yield*/, getCredential(provider, accessToken)];
                case 2:
                    credential = _a.sent();
                    return [2 /*return*/, authModule.linkWithCredential(user, credential)];
            }
        });
    });
}
exports.linkWithAccessToken = linkWithAccessToken;
function linkWithRedirect(user, provider, resolver) {
    return __awaiter(this, void 0, void 0, function () {
        var authModule;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, getAuthModule()];
                case 1:
                    authModule = _a.sent();
                    return [2 /*return*/, authModule.linkWithRedirect(user, provider, resolver)];
            }
        });
    });
}
exports.linkWithRedirect = linkWithRedirect;
function linkWithPopup(user, provider, resolver) {
    return __awaiter(this, void 0, void 0, function () {
        var authModule;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, getAuthModule()];
                case 1:
                    authModule = _a.sent();
                    return [2 /*return*/, authModule.linkWithPopup(user, provider, resolver)];
            }
        });
    });
}
exports.linkWithPopup = linkWithPopup;
function getRedirectResult(resolver) {
    return __awaiter(this, void 0, void 0, function () {
        var authModule;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, getAuthModule()];
                case 1:
                    authModule = _a.sent();
                    return [2 /*return*/, authModule.getRedirectResult(authModule.getAuth(), resolver)];
            }
        });
    });
}
exports.getRedirectResult = getRedirectResult;
function signInWithCredential(credential) {
    return __awaiter(this, void 0, void 0, function () {
        var authModule;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, getAuthModule()];
                case 1:
                    authModule = _a.sent();
                    return [2 /*return*/, authModule.signInWithCredential(authModule.getAuth(), credential)];
            }
        });
    });
}
exports.signInWithCredential = signInWithCredential;
function signInWithAccessToken(provider, accessToken) {
    return __awaiter(this, void 0, void 0, function () {
        var authModule, credential;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, getAuthModule()];
                case 1:
                    authModule = _a.sent();
                    return [4 /*yield*/, getCredential(provider, accessToken)];
                case 2:
                    credential = _a.sent();
                    return [2 /*return*/, authModule.signInWithCredential(authModule.getAuth(), credential)];
            }
        });
    });
}
exports.signInWithAccessToken = signInWithAccessToken;
function onAuthStateChanged(nextOrObserver, error, completed) {
    getAuthModule().then(function (authModule) {
        // ! TODO return unsubscribe function back
        authModule.onAuthStateChanged(authModule.getAuth(), nextOrObserver, error, completed);
    });
}
exports.onAuthStateChanged = onAuthStateChanged;
//# sourceMappingURL=index.js.map